/*

       
====================================================================

    MMIO     
RIFF/WAVE (.WAV),      
  ACM.    
   MME/Wave.

      ,
  MMIO.

*/





#pragma warning (disable: 4115 4201 4214 4514)


#if _DEBUG

  #pragma warning (disable: 4505)

#endif


#define STRICT

#include <windows.h>            //   Windows
#include <commctrl.h>           //    

#include <mmreg.h>              //   

#include <msacm.h>              //  ACM

#include <stdlib.h>             //    C/C++
#include <limits.h>             //   


#include "resource.h"           //  







//
// #########################################################################
//
//  
//
// #########################################################################
//





#define WaveBufferMS 500        //     
#define WaveBuffers 4           //  

#define SrcBufferMS 100         //     





//
// #########################################################################
//
// 
// 
// #########################################################################
//





enum {                          //   

  WMU_StopCompleted = WM_USER + 1024, //  

};





//
// #########################################################################
//
// 
// 
// #########################################################################
//





#ifdef _DEBUG

  #include <stdio.h>

  #define Debug DebugPrintF /*       */ 

#else

  #define Debug /##/

#endif


#define UNREF(x) (void)(x)





//
// #########################################################################
//
// 
// 
// #########################################################################
//




//
//  WaveFormat -   
//  WAVEFORMATEX    
//    .
//
//    C++  WaveFormat
//   ,    WAVEFORMATEX.
//

struct WaveFormat : public tWAVEFORMATEX {

  BYTE Ext [128];               //   

};





//
// #########################################################################
//
// 
// 
// #########################################################################
//





static HINSTANCE GlobalInst;    //   





//
// #########################################################################
//
// 
//
// #########################################################################
//


HWAVEOUT Out;                 //   

HACMSTREAM Stream;            //   

HMMIO File;                   //   

MMIOINFO FileInfo;            //   

WaveFormat SrcFmt;            //     ()
WAVEFORMATEX DstFmt;          //     (PCM)

UINT SampleRate;              //  
UINT BitsPerSample;           //  
UINT Channels;                //  

UINT WaveBufferSize;          //     PCM  

UINT AllocatedBuffers;        //   
UINT OutBuffers;              //     Wave Out

UINT SrcBufferSize;           //     
UINT DstBufferSize;           //      

BYTE *SrcBuffer;              //     
BYTE *DstBuffer;              //     

char *DstPtr;                 //     

DWORD DataBytesLeft;          //     

UINT SrcBytes;                //     
UINT DstBytes;                //     

DWORD ConvertFlags;           //   ACM

MMCKINFO RiffChunk;           //   RIFF  
MMCKINFO DataChunk;           //   data  

DWORD Flags;                  //  

  #define SF_Running 1        //  
  #define SF_StopReq 2        //  


HANDLE WorkerThreadHandle;    //   
DWORD WorkerThreadId;         //   



HWND DlgWin;                  //   

DWORD DefPrioClass;           //     

DWORD StartTime;              //    

char FileName [_MAX_PATH];    //    




//
// #########################################################################
//
// 
//
// #########################################################################
//





//
//   
// =======================
//

#ifdef _DEBUG

static void DebugPrintF (char *Format, ...) {

  char Str [256];
  va_list Args;

  wsprintf (Str, "%06u: ", (timeGetTime () - StartTime) % 1000000);

  va_start (Args, Format);
  wvsprintf (Str + strlen (Str), Format, Args);
  va_end (Args);

  strcat (Str, "\r\n");

  OutputDebugString (Str);

}

#endif





//
//    
// ==========================
//

void Error (char *Text) {

  MessageBox (DlgWin, Text, "Error", MB_ICONERROR | MB_OK);

}





//
//      
// ======================================================
//

LONG DlgMsg (int Id, UINT Msg, LPARAM lp, WPARAM wp) {

  return SendDlgItemMessage (DlgWin, Id, Msg, lp, wp);

}




//
// /    
// ================================================
//
//    
//

void EnableControls (BOOL Enable, ...) {

  va_list Ctrls;

  va_start (Ctrls, Enable);

  for (;;) {

    UINT Ctrl = va_arg (Ctrls, UINT);

    if (!Ctrl) {

      break;

    }

    EnableWindow (GetDlgItem (DlgWin, Ctrl), Enable);

  }

  va_end (Ctrls);

}





//
//    ComboBox 
// ====================================
//

void AddStringToCB (UINT Ctl, char *Str) {

  DlgMsg (Ctl,  CB_ADDSTRING,  0, (LPARAM)Str);

}





//
//     
// ====================================
//

void SetNumToCtl (UINT Ctl, UINT Num) {

  char Str [20];

  ultoa (Num, Str, 10);

  DlgMsg (Ctl,  WM_SETTEXT,  0, (LPARAM)Str);

}





//
//      
// ==================================================
//
//  UINT_MAX   
//

UINT GetNumFromCtl (UINT Ctl) {

  char Str [20];
  char *End;
  UINT Num;

  DlgMsg (Ctl,  WM_GETTEXT,  sizeof (Str), (LPARAM)Str);

  Num = strtoul (Str, &End, 10);

  if (*End && !isspace (*End)) {

    Num = UINT_MAX;

  }

  return Num;

}





//
//    
// ============================
//

DWORD RoundUp (DWORD Num, DWORD Block) {

  Num += Block - 1;

  return Num - Num % Block;

}





//
//     
// ===================================
//

UINT MsToBytes (WAVEFORMATEX *Fmt, UINT Ms) {

  UINT Size;

  //
  //    
  //

  Size = (Fmt->nAvgBytesPerSec * Ms + 500) / 1000;


  //
  //     
  //

  return RoundUp (Size, Fmt->nBlockAlign);

}





//
//   
// ==========================
//

void StopDevices (void) {

  Flags |= SF_StopReq;

  waveOutReset (Out);

}





//
//  
// =====================
//

void Cleanup (void) {

  if (Out) {

    waveOutReset (Out);

  }

  if (SrcBuffer) {

    LocalFree (SrcBuffer);
    SrcBuffer = NULL;

  }

  if (DstBuffer) {

    LocalFree (DstBuffer);
    DstBuffer = NULL;

  }

  if (WorkerThreadHandle && !AllocatedBuffers) {

    PostThreadMessage (WorkerThreadId, WM_QUIT, 0, 0);

  }

}





//
//  
// ====================
//

void CloseDevices (void) {

  if (Out) {

    waveOutClose (Out);

    Out = NULL;

  }

  if (Stream) {

    acmStreamClose (Stream, 0);

    Stream = NULL;

  }

  if (File) {

    mmioClose (File, 0);

    File = NULL;

  }

}





//
//    
// ==================================

void Restore (void) {

  SetPriorityClass (GetCurrentProcess (), DefPrioClass);

  EnableWindow (GetDlgItem (DlgWin, IDC_StartStop), TRUE);

}





//
//   
// =============================
//


void ReleaseBuffer (WAVEHDR *Hdr) {

  LocalFree (Hdr->lpData);
  LocalFree (Hdr);

  if (!--AllocatedBuffers) {    //    

    //
    //      
    //

    PostThreadMessage (WorkerThreadId, WM_QUIT, 0, 0);

  }

}





//
//   
// ==========================
//
//         FileName
//

BOOL SelectFile (void) {

  char Filters [64];            //     

  OPENFILENAME OF;              //    

  wsprintf (Filters, "%s%c%s%c", " RIFF/WAVE (*.wav)", 0, "*.wav", 0);

  memset (&OF, 0, sizeof (OF));

  OF.lStructSize = sizeof (OF);
  OF.hwndOwner = DlgWin;
  OF.lpstrFilter = Filters;
  OF.lpstrFile = FileName;
  OF.nMaxFile = sizeof (FileName);
  OF.lpstrTitle = "  ";
  OF.Flags = OFN_FILEMUSTEXIST | OFN_LONGNAMES;

  return GetOpenFileName (&OF);

}





//
//     
// ===================================
//
//   
//
//        SrcFmt,
//     
//

BOOL OpenFile (void) {

  MMRESULT Res;

  //
  //  
  //

  File = mmioOpen (
    FileName,
    NULL,
    MMIO_READ | MMIO_ALLOCBUF | MMIO_DENYWRITE
  );

  if (!File) {

    Error ("  ");

    return FALSE;

  }


  //
  //   RIFF
  //

  RiffChunk.fccType = mmioFOURCC ('W', 'A', 'V', 'E');

  Res = mmioDescend (File, &RiffChunk, NULL, MMIO_FINDRIFF);

  if (Res) {

    Error ("    RIFF/WAVE");

    return FALSE;

  }


  //
  //   fmt
  //

  MMCKINFO FmtChunk;

  FmtChunk.ckid = mmioFOURCC ('f', 'm', 't', ' ');

  Res = mmioDescend (File, &FmtChunk, &RiffChunk, MMIO_FINDCHUNK);

  if (Res) {

    Error ("     ");

    return FALSE;

  }


  if (FmtChunk.cksize > sizeof (SrcFmt)) {

    Error ("    ");

    return FALSE;

  }


  //
  //     SrcFmt
  //

  DWORD N;

  N = mmioRead (File, (char *)&SrcFmt, FmtChunk.cksize);

  if (N  != FmtChunk.cksize) {

    Error ("   ");

    return FALSE;

  }


  //
  //   data
  //

  DataChunk.ckid = mmioFOURCC ('d', 'a', 't', 'a');

  Res = mmioDescend (File, &DataChunk, &RiffChunk, MMIO_FINDCHUNK);

  if (Res) {

    Error ("     ");

    return FALSE;

  }

  DataBytesLeft = DataChunk.cksize; //   


  return TRUE;

}





//
//     
// ====================================
//


int OpenDevices (void) {

  MMRESULT Res;
  
  Out = NULL;
  AllocatedBuffers = 0;


  //
  //  
  //

  SrcBytes = DstBytes = 0;

  ConvertFlags = ACM_STREAMCONVERTF_START | ACM_STREAMCONVERTF_BLOCKALIGN;


  //
  //  
  //

  if (!OpenFile ()) {

    return FALSE;

  }


  //
  //   
  //

  DstFmt.wFormatTag = WAVE_FORMAT_PCM; //    PCM

  Res = acmFormatSuggest (
    NULL,
    &SrcFmt,
    &DstFmt,
    sizeof (DstFmt),
    ACM_FORMATSUGGESTF_WFORMATTAG
  );

  if (Res != MMSYSERR_NOERROR) {

    Error ("   ");

    return FALSE;

  }


  //
  //   
  //

  Res = acmStreamOpen (&Stream, NULL, &SrcFmt, &DstFmt, NULL, 0, 0, 0);

  if (Res != MMSYSERR_NOERROR) {

    Error ("   ");

    return FALSE;

  }


  //
  //    
  //

  SrcBufferSize = MsToBytes (&SrcFmt, SrcBufferMS);


  //
  //     MS/IMA ADPCM
  //

  SrcBufferSize = RoundUp (SrcBufferSize, 4096);

  Debug ("Source buffer size - %u", SrcBufferSize);


  //
  //     
  //

  SrcBuffer = (BYTE *)LocalAlloc (LMEM_FIXED, SrcBufferSize);

  if (!SrcBuffer) {

    Error ("    ");

    return FALSE;

  }


  //
  //    
  //

  Res = acmStreamSize (
    Stream,
    SrcBufferSize,
    (DWORD *)&DstBufferSize,
    ACM_STREAMSIZEF_SOURCE
  );

  if (Res != MMSYSERR_NOERROR) {

    Error ("    ");

    return FALSE;

  }

  if (!DstBufferSize) {

    Error ("     ");

    return FALSE;

  }


  Debug ("Destination buffer size - %u", DstBufferSize);


  //
  //     
  //

  DstBuffer = (BYTE *)LocalAlloc (LMEM_FIXED, DstBufferSize);

  if (!DstBuffer) {

    Error ("    ");

    return FALSE;

  }


  //
  //    
  //

  if (mmioSetBuffer (File, (char *)SrcBuffer, SrcBufferSize, 0)) {

    Error ("    ");

    return FALSE;

  }


  //
  //    
  //

  if (mmioGetInfo (File, &FileInfo, 0)) {

    Error ("    ");

    return FALSE;

  }


  //
  //      
  //

  int  DevN = DlgMsg (IDC_WaveOut, CB_GETCURSEL, 0, 0);


  //
  //    ,   
  //

  Res = waveOutOpen (
    &Out,
    DevN - 1,
    &DstFmt,
    (DWORD)WorkerThreadId,
    0,
    CALLBACK_THREAD
  );


  if (Res != MMSYSERR_NOERROR) {

    //
    //    
    //

    Error ("   ");

    return FALSE;

  }


  waveOutPause (Out);           //    


  //
  //    
  //

  WaveBufferSize = MsToBytes (&DstFmt, WaveBufferMS / WaveBuffers);

  Debug ("Wave buffer size - %u", WaveBufferSize);


  //
  //      ,   
  //     
  //

  for (int N = WaveBuffers; N > 0; N--) {

    char *Buf = (char *)LocalAlloc (LMEM_FIXED, WaveBufferSize);
    WAVEHDR *Hdr = (WAVEHDR *)LocalAlloc (LMEM_FIXED, sizeof (*Hdr));

    if (Buf && Hdr) {

      //
      //   
      //

      Hdr->lpData = Buf;
      Hdr->dwBufferLength = WaveBufferSize;
      Hdr->dwFlags = 0;
      Hdr->dwLoops = 0;
      Hdr->dwUser = 0;


      //
      //    
      //

      waveOutPrepareHeader (Out, Hdr, sizeof (*Hdr));
      Res = waveOutWrite (Out, Hdr, sizeof (*Hdr));

    }

    if (Buf && Hdr && Res == MMSYSERR_NOERROR) {

      AllocatedBuffers++;
      OutBuffers++;

    } else {

      //
      // .   
      //

      if (Buf) {

        LocalFree (Buf);

      }

      if (Hdr) {

        LocalFree (Hdr);

      }

      if (!Hdr || !Buf) {

        Error ("    ");

      } else {

        Error ("    ");

      }

      return FALSE;

    }

  }

  return TRUE;

}





//
//    
// ====================================
//
//     
//

BOOL CompressSrcBuffer (void) {

  MMRESULT Res;
  BOOL Last;                    //   


  //
  //   
  //

  Last = (DWORD (FileInfo.pchEndRead - FileInfo.pchNext) == DataBytesLeft);

  ACMSTREAMHEADER AH;

  AH.cbStruct = sizeof (AH);
  AH.fdwStatus = 0;
  AH.pbSrc = (BYTE *)FileInfo.pchNext;
  AH.cbSrcLength = FileInfo.pchEndRead - FileInfo.pchNext;
  AH.pbDst = DstBuffer;
  AH.cbDstLength = DstBufferSize;

  //
  //  
  //

  Res = acmStreamPrepareHeader (Stream, &AH, 0);

  if (Res != MMSYSERR_NOERROR) {

    StopDevices ();

    Error ("   ");

    return FALSE;

  }


  //
  //    -    
  //

  if (Last) {
  
    ConvertFlags &= ~ACM_STREAMCONVERTF_BLOCKALIGN;
    ConvertFlags |= ACM_STREAMCONVERTF_END;

  }


  //
  //  
  //

  Res = acmStreamConvert (Stream, &AH, ConvertFlags);

  //
  //  
  //

  acmStreamUnprepareHeader (Stream, &AH, 0);


  ConvertFlags &= ~ACM_STREAMCONVERTF_START; //     

  if (Res != MMSYSERR_NOERROR) {

    StopDevices ();

    Error ("   ");

    return FALSE;

  }


  //
  //      - 
  //

  if (!AH.cbSrcLengthUsed && !AH.cbDstLengthUsed) {

    StopDevices ();

    Error ("   ");

    return FALSE;

  }


  //
  //     
  //

  FileInfo.pchNext += AH.cbSrcLengthUsed;

  DstPtr = (char *)DstBuffer;
  DstBytes = AH.cbDstLengthUsed;

  DataBytesLeft -= AH.cbSrcLengthUsed;

  return TRUE;

}





//
//  
// ==============
//

DWORD WINAPI WorkerThreadProc (void *Arg) {

  //
  //      
  //

  SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_TIME_CRITICAL);

  MSG Msg;

  //
  //         WM_QUIT
  //    
  //

  while (GetMessage (&Msg, NULL, 0, 0) == TRUE) {

    switch (Msg.message) {





      //
      //     
      //

      case MM_WOM_DONE: {

        WAVEHDR *Hdr = (WAVEHDR *)Msg.lParam;

        MMRESULT Res;

        OutBuffers--;


        DWORD WaveBytes = 0;    //     

        while (WaveBytes < WaveBufferSize && !(Flags & SF_StopReq)) {


          //
          //     -  - 
          //

          if (DstBytes) {

            DWORD Portion = min (WaveBufferSize - WaveBytes, DstBytes);

            memcpy (Hdr->lpData + WaveBytes, DstPtr, Portion);

            WaveBytes += Portion;
            DstPtr += Portion;
            DstBytes -= Portion;

          }


          //
          //     -   
          //

          if (!DstBytes) {


            //
            //     - 
            //

            if (FileInfo.pchNext == FileInfo.pchEndRead) {

              if (mmioAdvance (File, &FileInfo, MMIO_READ)) {

                StopDevices ();

                Error ("   ");

                goto Exit;

              }

            }


            if (FileInfo.pchNext != FileInfo.pchEndRead) {

              //
              //    
              //

              if (!CompressSrcBuffer ()) {

                goto Exit;

              }

            }


            if ((Flags & SF_StopReq) || !DstBytes || !DataBytesLeft) {

              break;          //   

            }

          }

        }


        if (WaveBytes) {

          //
          // -  - 
          //

          Hdr->dwBufferLength = WaveBytes;

          Res = waveOutWrite (Out, Hdr, sizeof (*Hdr));

          if (Res == MMSYSERR_NOERROR) {

            OutBuffers++;

          } else {

            StopDevices ();

            Error ("    ");

            goto Exit;

          }

        } else {

          //
          //    -  
          //

          waveOutUnprepareHeader (Out, Hdr, sizeof (*Hdr));

          ReleaseBuffer (Hdr);

        }


        break;

      }





    }

  }

  Exit:

  if (File) {

    mmioClose (File, 0);        //  

    File = NULL;

  }


  //
  //       -
  //

  PostMessage (DlgWin, WMU_StopCompleted, 0, 0);

  return 0;

  UNREF (Arg);

}




//
//    
// =====================================
//

BOOL CALLBACK DialogProc (HWND Win, UINT Msg, WPARAM wp, LPARAM lp) {

  DlgWin = Win;

  switch (Msg) {





    //
    //   
    // ==============================
    //

    case WM_INITDIALOG: {

      int NumWaveDevs;
      int i;

      DefPrioClass = GetPriorityClass (GetCurrentProcess ());


      //
      //    ,   Wave Mapper
      //

      NumWaveDevs = waveOutGetNumDevs ();
      
      for (i = 0; i < NumWaveDevs + 1; i++) {
        
        WAVEOUTCAPS DevCaps;

        waveOutGetDevCaps (i - 1, &DevCaps, sizeof (DevCaps));

        AddStringToCB (IDC_WaveOut, DevCaps.szPname);
        
      }

      DlgMsg (IDC_WaveOut, CB_SETCURSEL, 0, 0);


      return TRUE;

    }





    //
    //   Windows
    // ===========================
    //

    case WM_COMMAND: {

      UINT CtrlId = LOWORD (wp);
      UINT CtrlMsg = HIWORD (wp);
      
      switch (CtrlId) {
        

        //
        //     -     
        // =================================================================
        //

        case IDCANCEL: {

          if (!(Flags & SF_Running)) {

            EndDialog (DlgWin, 0);
            return TRUE;

          }

          break;

        }
        



        //
        //   /
        // ===============================
        //

        case IDC_StartStop: {

          //
          //     
          //

          EnableWindow (GetDlgItem (DlgWin, IDC_StartStop), 0);

          if (!(Flags & SF_Running)) { // 

            if (!SelectFile ()) { //    

              Restore ();       // 

              break;

            }


            OutBuffers = 0;

            StartTime = timeGetTime ();

            timeBeginPeriod (1); //   - 1 


            //
            //   
            //

            SetPriorityClass (GetCurrentProcess (), HIGH_PRIORITY_CLASS);


            //
            //   
            //

            WorkerThreadHandle = CreateThread (
              NULL,
              0,
              WorkerThreadProc,
              NULL,
              0,
              &WorkerThreadId
            );


            //
            //    
            //

            if (OpenDevices ()) {

              //
              //  
              //  


              //
              //   
              //

              EnableControls (FALSE, IDC_WaveOut, 0);

              
              //
              //    
              //

              DlgMsg (IDC_StartStop, WM_SETTEXT, 0, (LPARAM)"");

              Flags |= SF_Running;

              waveOutReset (Out); //   

            } else {

              Cleanup ();

            }

          } else { // 

            StopDevices ();

            timeEndPeriod (1);  //   

          }

          if (!(Flags & SF_StopReq)) {

            //
            //     -  
            //
                
            Restore ();

          }

          break;
        
        }

      }

      break;

    }





    //
    //   
    // ===========================
    //

    case WMU_StopCompleted: {
    
      timeEndPeriod (1);        //   

      //
      //      
      //

      CloseHandle (WorkerThreadHandle);

      WorkerThreadId = 0;
      WorkerThreadHandle = NULL;

      CloseDevices ();

      Cleanup ();               //  


      //
      //      
      //

      Restore ();

      Flags &= ~(SF_Running | SF_StopReq);


      //
      //   
      //

      EnableControls (TRUE, IDC_WaveOut, 0);


      //
      //       
      //

      DlgMsg (IDC_StartStop, WM_SETTEXT, 0, (LPARAM)"");

      EnableWindow (GetDlgItem (DlgWin, IDC_StartStop), 1);


      break;

    }  





  }

  return FALSE;

  UNREF (lp);

}
      

//
//   Windows
// ========================
//

int WINAPI WinMain (
  HINSTANCE Instance,
  HINSTANCE PrevInstance,
  LPSTR Cmd,
  int CmdShow
) {

  int Result;
  

  //
  //     
  //

  InitCommonControls ();


  GlobalInst = Instance;


  //
  //   
  //

  Result = DialogBox (
    Instance, 
    MAKEINTRESOURCE (IDD_RptDialog),
    HWND_DESKTOP,
    DialogProc
  );


  return Result;

  UNREF (PrevInstance);
  UNREF (Cmd);
  UNREF (CmdShow);

}
